// transitions implémentées 19/06/2018 1.0.3.67

// *** pré-traitement des transitions ***

procedure TGVTransition.DoPrepareSpline;
// *** SplineRight et SplinesLeft (préparation) ***
var
 LI, LHS: Integer;
begin
  LHS := Max(fHorizontalStrips, C_MinPointsSpline);
  SetLength(fPts, LHS);
  SetLength(fPtsTemp, LHS);
  fPts[0] := PointF(0, 0);
  fPtsTemp[1] := fPts[0];
  fPts[Length(fPts) - 1] := PointF(0, ClientHeight);
  fPtsTemp[Length(fPts) - 2] := fPts[Length(fpts) - 1];
  for LI := 2 to Length(fPts) - 3 do
  begin
    fPtsTemp[LI].y := ClientHeight / Length(fPts) * LI;
    if random < 0.6 then
      fPtsTemp[LI].x := random(ClientWidth div 3)
    else
      fPtsTemp[Li].x := 0;
  end;
end;

procedure TGVTransition.DoPrepareSplineUpOrDown;
// *** SplineDown et SplinesUp (préparation) ***
var
 LI, LVS: Integer;
begin
  LVS := Max(fVerticalStrips, C_MinPointsSpline);
  SetLength(fPts, LVS);
  SetLength(fPtsTemp, LVS);
  fPts[0] := PointF(0, 0);
  fPtsTemp[1] := fPts[0];
  fPts[Length(fPts) - 1] := PointF(ClientWidth, 0);
  fPtsTemp[Length(fPts) - 2] := fPts[Length(fpts) - 1];
  for LI := 2 to Length(fPts) - 3 do
  begin
    fPtsTemp[LI].x := ClientWidth / Length(fPts) * LI;
    if random < 0.6 then
      fPtsTemp[LI].y := random(ClientHeight div 3)
    else
      fPtsTemp[LI].y := 0;
  end;
end;

// *** préparation des transitions (source) ***

procedure TGVTransition.DoUp;
// *** image vers le haut ***
begin
  fY := ComputeInterpolation(0, -ClientHeight);
end;

procedure TGVTransition.DoDown;
// *** image vers le bas ***
begin
  fY := ComputeInterpolation(0, ClientHeight);
end;

procedure TGVTransition.DoRight;
// *** image vers la droite ***
begin
  fX := ComputeInterpolation(0, ClientWidth);
end;

procedure TGVTransition.DoLeft;
// *** image vers la gauche ***
begin
  fX := ComputeInterpolation(0, -ClientWidth);
end;

procedure TGVTransition.DoBottomRight;
// *** image vers le bas à droite ***
begin
  DoRight;
  DoDown;
end;

procedure TGVTransition.DoBottomLeft;
// *** image vers le bas à gauche ***
begin
  DoLeft;
  DoDown;
end;

procedure TGVTransition.DoTopRight;
// *** image vers le haut à droite ***
begin
  DoRight;
  DoUp;
end;

procedure TGVTransition.DoTopLeft;
// *** image vers le haut à gauche ***
begin
  DoLeft;
  DoUp;
end;

// *** transitions ***

procedure TGVTransition.DoUncoverUpOrDown(Up: boolean);
// *** UncoverDown et UncoverUp ***
begin
  fLBGRAMask.FillRectAntialias(0,
    ifthen(Up, ComputeInterpolation(ClientHeight, 0),
      ComputeInterpolation(-ClientHeight, 0)), ClientWidth,
    ifthen(Up, ClientHeight, ComputeInterpolation(0, ClientHeight)), BGRAWhite);
end;

procedure TGVTransition.DoUncover(ToRight: boolean);
// *** UncoverLeft et UncoverRight ***
begin
  fLBGRAMask.FillRectAntialias(
    ifthen(ToRight, ComputeInterpolation(-ClientWidth, 0),
    ComputeInterpolation(ClientWidth, 0)), 0,
    ifthen(ToRight, ComputeInterpolation(0, ClientWidth), ClientWidth),
    ClientHeight, BGRAWhite);
end;

procedure TGVTransition.DoOverUpOrDown(Up: boolean);
// *** OverDown et OverUp ***
begin
  DoUncoverUpOrDown(Up);
  fY := ifthen(Up, ComputeInterpolation(ClientHeight, 0),
    ComputeInterpolation(-ClientHeight, 0));
end;

procedure TGVTransition.DoOver(ToRight: boolean);
// *** OverLeft et OverRight ***
begin
  DoUncover(ToRight);
  fX := ifthen(ToRight, ComputeInterpolation(-ClientWidth, 0),
    ComputeInterpolation(ClientWidth, 0));
end;

procedure TGVTransition.DoUncoverBottom(ToRight: boolean);
// *** UncoverBottomRight et UncoverBottomLeft ***
begin
  fLBGRAMask.FillRectAntialias(
    ifthen(ToRight, 0, ComputeInterpolation(ClientWidth, 0)), 0,
    ifthen(ToRight, ComputeInterpolation(0, ClientWidth), ClientWidth),
    ComputeInterpolation(0, ClientHeight), BGRAWhite);
end;

procedure TGVTransition.DoUncoverTop(ToRight: boolean);
// *** UncoverTopRight  et UncoverTopLeft ***
begin
  fLBGRAMask.FillRectAntialias(
    ifthen(ToRight, 0, ComputeInterpolation(ClientWidth, 0)),
    ComputeInterpolation(ClientHeight, 0),
    ifthen(ToRight, ComputeInterpolation(0, ClientWidth), ClientWidth),
    ClientHeight, BGRAWhite);
end;

procedure TGVTransition.DoUncoverHorizontalBackAndForth;
// *** UncoverHorizontalBackAndForth ***
begin
  fLBGRAMask.FillRectAntialias(0, ComputeInterpolation(ClientHeight, 0),
    ClientWidth, ComputeInterpolation(0, ClientHeight), BGRAWhite);
end;

procedure TGVTransition.DoUncoverVerticalBackAndForth;
// *** UncoverVerticalBackAndForth ***
begin
  fLBGRAMask.FillRectAntialias(ComputeInterpolation(ClientWidth, 0),0,
    ComputeInterpolation(0, ClientWidth), ClientHeight, BGRAWhite);
end;

procedure TGVTransition.DoOverSlipBottom(ToRight: boolean);
// *** OverSlipBottomRight et OverSlipBottomLeft ***
begin
  DoUncoverBottom(ToRight);
  fX := ifthen(ToRight, ComputeInterpolation(-ClientWidth, 0),
    ComputeInterpolation(ClientWidth, 0));
end;

procedure TGVTransition.DoOverSlipTop(ToRight: boolean);
// *** OverSlipTopRight et OverSlipTopLeft ***
begin
  DoUncoverTop(ToRight);
  fX := ifthen(ToRight, ComputeInterpolation(-ClientWidth, 0),
    ComputeInterpolation(ClientWidth, 0));
end;

procedure TGVTransition.DoOverBottom(ToRight: boolean);
// *** OverBottomRight et OverBottomLeft ***
begin
  DoOverSlipBottom(ToRight);
  fY := ComputeInterpolation(-ClientHeight, 0);
end;

procedure TGVTransition.DoOverTop(ToRight: boolean);
// *** OverTopRight et OverTopLeft ***
begin
  DoOverSlipTop(ToRight);
  fY := ComputeInterpolation(ClientHeight, 0);
end;

procedure TGVTransition.DoBottomExpand(ToRight: boolean);
// *** BottomRightExpand et BottomLeftExpand ***
begin
  fLBGRAMask.FillRectAntialias(ifthen(ToRight, 0, ClientWidth), 0,
    ifthen(ToRight, ComputeInterpolation(0, ClientWidth),
    ComputeInterpolation(ClientWidth, 0)), ComputeInterpolation(0, ClientHeight),
    BGRAWhite);
end;

procedure TGVTransition.DoTopExpand(ToRight: boolean);
// *** TopRightExpand et TopLeftExpand ***
begin
  fLBGRAMask.FillRectAntialias(ifthen(ToRight, 0, ClientWidth), ClientHeight,
    ifthen(ToRight, ComputeInterpolation(0, ClientWidth),
    ComputeInterpolation(ClientWidth, 0)), ComputeInterpolation(ClientHeight, 0),
    BGRAWhite);
end;

procedure TGVTransition.DoLeaveUpOrDown(Up: boolean);
// *** LeaveUp et LeaveDown ***
begin
  fLBGRAMask.FillRectAntialias(0,
    ifthen(Up, ComputeInterpolation(ClientHeight, 0), 0),
    ClientWidth, ifthen(Up, ClientHeight, ComputeInterpolation(0, ClientHeight)),
    BGRAWhite);
end;

procedure TGVTransition.DoLeave(ToRight: boolean);
// *** LeaveLeft et LeaveRight ***
begin
  fLBGRAMask.FillRectAntialias(
    ifthen(ToRight, 0, ComputeInterpolation(ClientWidth, 0)), 0,
    ifthen(ToRight, ComputeInterpolation(0, ClientWidth), ClientWidth),
    ClientHeight, BGRAWhite);
end;

procedure TGVTransition.DoLeaveBottom(ToRight: boolean);
// *** LeaveBottomRight et LeaveBottomLeft ***
begin
  DoUncover(ToRight);
  DoUncoverUpOrDown(False);
end;

procedure TGVTransition.DoLeaveTop(ToRight: boolean);
// *** LeaveTopLeft et LeaveTopRight ***
begin
  DoUncover(ToRight);
  DoUncoverUpOrDown(True);
end;

procedure TGVTransition.DoVerticalExpand;
// *** VerticalExpand ***
begin
 fLBGRAMask.FillRectAntialias(ComputeInterpolation(ClientWidth / 2, 0), 0,
   ComputeInterpolation(ClientWidth / 2, ClientWidth), ClientHeight,
   BGRAWhite, False);
end;

procedure TGVTransition.DoHorizontalExpand;
// *** HorizontalExpand ***
begin
  fLBGRAMask.FillRectAntialias(0, ComputeInterpolation(ClientHeight / 2, 0),
    ClientWidth, ComputeInterpolation(ClientHeight / 2, ClientHeight),
    BGRAWhite);
end;

procedure TGVTransition.DoHorizontalShrink;
// *** HorizontalShrink ***
begin
  fLBGRAMask.FillRectAntialias(0, ComputeInterpolation(0, ClientHeight / 2),
    ClientWidth, ComputeInterpolation(ClientHeight, ClientHeight / 2),
    BGRAWhite);
  DoNegateMask;
end;

procedure TGVTransition.DoVerticalShrink;
// *** VerticalShrink ***
begin
  fLBGRAMask.FillRectAntialias(ComputeInterpolation(0, ClientWidth / 2),
    0, ComputeInterpolation(ClientWidth, ClientWidth / 2), ClientHeight,
    BGRAWhite);
  DoNegateMask;
end;

procedure TGVTransition.DoRectExpand;
// *** RectExpand ***
begin
  fLBGRAMask.FillRectAntialias(
    ComputeInterpolation(ClientWidth / 2, 0),
    ComputeInterpolation(ClientHeight / 2, 0),
    ComputeInterpolation(ClientWidth / 2, ClientWidth),
    ComputeInterpolation(ClientHeight / 2,ClientHeight),
    BGRAWhite);
end;

procedure TGVTransition.DoRectShrink;
// *** RectShrink ***
begin
  fLBGRAMask.FillRectAntialias(
    ComputeInterpolation(0, ClientWidth / 2),
    ComputeInterpolation(0, ClientHeight / 2),
    ComputeInterpolation(ClientWidth, ClientWidth / 2),
    ComputeInterpolation(ClientHeight,ClientHeight / 2),
    BGRAWhite);
  DoNegateMask;
end;

procedure TGVTransition.DoEllipseExpand;
// *** EllipseExpand ***
begin
  fLBGRAMask.FillEllipseAntialias(ClientWidth / 2, ClientHeight / 2,
    ComputeInterpolation(0, ClientWidth), ComputeInterpolation(0, ClientHeight),
    BGRAWhite);
end;

procedure TGVTransition.DoEllipseShrink;
// *** EllipseShrink ***
begin
  fLBGRAMask.FillEllipseAntialias(ClientWidth / 2, ClientHeight / 2,
    ComputeInterpolation(ClientWidth, 0), ComputeInterpolation(ClientHeight, 0),
    BGRAWhite);
  DoNegateMask;
end;

procedure TGVTransition.DoDiskExpand;
// *** DiskExpand ***
var
  LRay: Integer;
begin
  LRay := Max(ClientWidth, ClientHeight);
  fLBGRAMask.FillEllipseAntialias(ClientWidth / 2, ClientHeight / 2,
    ComputeInterpolation(0, LRay), ComputeInterpolation(0, LRay), BGRAWhite);
end;

procedure TGVTransition.DoDiskShrink;
// *** DiskShrink ***
var
  LRay: Integer;
begin
  LRay := Max(ClientWidth, ClientHeight);
  fLBGRAMask.FillEllipseAntialias(ClientWidth / 2, ClientHeight / 2,
    ComputeInterpolation(LRay, 0), ComputeInterpolation(LRay, 0), BGRAWhite);
  DoNegateMask;
end;

procedure TGVTransition.DoCrossExpand;
// *** CrossExpand ***
begin
  DoVerticalExpand;
  DoHorizontalExpand;
end;

procedure TGVTransition.DoCrossShrink;
// *** CrossShrink ***
begin
  DoHorizontalShrink;
  DoNegateMask;
  DoVerticalShrink;
end;

procedure TGVTransition.DoShrinkExpandUpOrDown(Up: boolean);
// *** ShrinkExpandDown et ShrinkExpandUp ***
begin
 fLBGRAMask.FillRectAntialias(ComputeInterpolation(ClientWidth, 0),
   ifthen(Up, ComputeInterpolation(ClientHeight, 0), 0),
   ComputeInterpolation(0, ClientWidth),
   ifthen(Up, ClientHeight,ComputeInterpolation(0, ClientHeight)),
   BGRAWhite);
end;

procedure TGVTransition.DoTrianglesExpand;
// *** TrianglesExpand ***
begin
  SetLength(fPts, 3);
  fPts[0] := PointF(0, 0);
  fPts[1].x := ComputeInterpolation(0, ClientWidth / 2) + 0.5;
  fPts[1].y := ClientHeight / 2;
  fPts[2] := PointF(0, ClientHeight);
  fLBGRAMask.FillPolyAntialias(fPts, BGRAWhite);

  fPts[0].x := ClientWidth;
  fPts[1].x := ComputeInterpolation(ClientWidth, ClientWidth / 2) - 0.5;
  fPts[2].x := ClientWidth;
  fLBGRAMask.FillPolyAntialias(fPts, BGRAWhite);

  fPts[0] := PointF(0, ClientHeight);
  fPts[1].x := ClientWidth / 2;
  fPts[1].y := ComputeInterpolation(ClientHeight, ClientHeight / 2) - 0.5;
  fLBGRAMask.FillPolyAntialias(fPts, BGRAWhite);

  fPts[0].y := 0;
  fPts[1].y := ComputeInterpolation(0, ClientHeight / 2) + 0.5;
  fPts[2].y := 0;
  fLBGRAMask.FillPolyAntialias(fPts, BGRAWhite);
end;

procedure TGVTransition.DoTrianglesShrink;
// *** TrianglesShrink ***
begin
  SetLength(fPts, 3);
  fPts[0] := PointF(0, 0);
  fPts[1].x := ComputeInterpolation(ClientWidth / 2, 0) - 0.5;
  fPts[1].y := ClientHeight / 2;
  fPts[2] := PointF(0, ClientHeight);
  fLBGRAMask.FillPolyAntialias(fPts, BGRAWhite);

  fPts[0].x := ClientWidth;
  fPts[1].x := ComputeInterpolation(ClientWidth / 2, ClientWidth) + 0.5;
  fPts[2].x := ClientWidth;
  fLBGRAMask.FillPolyAntialias(fPts, BGRAWhite);

  fPts[0] := PointF(0, ClientHeight);
  fPts[1].x := ClientWidth / 2;
  fPts[1].y := ComputeInterpolation(ClientHeight / 2, ClientHeight) + 0.5;
  fLBGRAMask.FillPolyAntialias(fPts, BGRAWhite);

  fPts[0].y := 0;
  fPts[1].y := ComputeInterpolation(ClientHeight / 2, 0) - 0.5;
  fPts[2].y := 0;
  fLBGRAMask.FillPolyAntialias(fPts, BGRAWhite);
  DoNegateMask;
end;

procedure TGVTransition.DoMegaStar;
// *** MegaStar ***
begin
  SetLength(fPts, 3);
  fPts[0].x := ComputeInterpolation(ClientWidth / 3, 0);
  fPts[0].y := ComputeInterpolation(ClientHeight / 3 * 2, ClientHeight);
  fPts[1].x := ClientWidth / 2;
  fPts[1].y := ComputeInterpolation(ClientHeight / 3, 0);
  fPts[2].x := ComputeInterpolation(ClientWidth / 3 * 2, ClientWidth);
  fPts[2].y := fPts[0].y;
  fLBGRAMask.FillPolyAntialias(fPts, BGRAWhite);

  fPts[0].y := ComputeInterpolation(ClientHeight / 2, 0);
  fPts[1] := PointF(fPts[2].x, fpts[0].y);
  fPts[2].x := ClientWidth / 2;
  fPts[2].y := ComputeInterpolation(ClientHeight / 6 * 5, ClientHeight);
  fLBGRAMask.FillPolyAntialias(fPts, BGRAWhite);

  fPts[0] := PointF(0, 0);
  fPts[1].x := ComputeInterpolation(0, ClientWidth / 4 + 5);
  fPts[1].y := ClientHeight / 2;
  fPts[2] := PointF(fPts[0].x, ClientHeight);
  fLBGRAMask.FillPolyAntialias(fPts, BGRAWhite);

  fPts[0].x := ClientWidth;
  fPts[1].x := ComputeInterpolation(ClientWidth, ClientWidth / 4 * 3 - 5);
  fPts[2].x := fPts[0].x;
  fLBGRAMask.FillPolyAntialias(fPts, BGRAWhite);
end;

procedure TGVTransition.DoSplinesDown;
// *** SplinesDown ***
var
  LI: Integer;
  LSpline: array of TPointF;
begin
  for LI := 1 to Length(fPts) - 2 do
  begin
    fPts[LI].x := fPtsTemp[LI].x;
    fPts[LI].y := ComputeInterpolation(fPtsTemp[LI].y, ClientHeight);
  end;
  LSpline := fLBGRAMask.ComputeOpenedSpline(fPts, ssOutside);
  fLBGRAMask.DrawPolyLineAntialias(LSpline, BGRAWhite, 1, BGRAWhite);
end;

procedure TGVTransition.DoSplinesUp;
// *** SplinesUp ***
var
  LI: Integer;
  LSpline: array of TPointF;
begin
  for LI := 1 to Length(fPts) - 2 do
  begin
    fPts[LI].x := fPtsTemp[LI].x;
    fPts[LI].y := ComputeInterpolation(ClientHeight - fPtsTemp[LI].y, 0);
  end;
  LSpline := fLBGRAMask.ComputeOpenedSpline(fPts, ssOutside);
  fLBGRAMask.DrawPolyLineAntialias(LSpline, BGRAWhite, 1, BGRAWhite);
  DoNegateMask;
end;

procedure TGVTransition.DoSplinesRight;
// *** SplinesRight ***
var
  LI: Integer;
  LSpline: array of TPointF;
begin
  for LI := 1 to Length(fPts) - 2 do
  begin
    fPts[LI].x := ComputeInterpolation(fPtsTemp[LI].x, ClientWidth);
    fPts[LI].y := fPtsTemp[LI].y;
  end;
  LSpline := fLBGRAMask.ComputeOpenedSpline(fPts, ssOutside);
  fLBGRAMask.DrawPolyLineAntialias(LSpline, BGRAWhite, 1, BGRAWhite);
end;

procedure TGVTransition.DoSplinesLeft;
// *** SplinesLeft ***
var
  LI: Integer;
  LSpline: array of TPointF;
begin
  for LI := 1 to Length(fPts) - 2 do
  begin
    fPts[LI].x := ComputeInterpolation(ClientWidth - fPtsTemp[LI].x, 0);
    fPts[LI].y := fPtsTemp[LI].y;
  end;
  LSpline := fLBGRAMask.ComputeOpenedSpline(fPts, ssOutside);
  fLBGRAMask.DrawPolyLineAntialias(LSpline, BGRAWhite, 1, BGRAWhite);
  DoNegateMask;
end;

procedure TGVTransition.DoStripsUpOrDown(Up: boolean);
// *** StripsDown et StripsUp ***
var
  LI: Integer;
  LHeight: Single;
begin
  LHeight := ClientHeight / fHorizontalStrips;
  for LI := 0 to fHorizontalStrips do
  begin
    fLBGRAMask.FillRectAntialias(0,
      ifthen(Up, ComputeInterpolation(LHeight * (LI + 1), LHeight * LI),
      -0.5 + LHeight * LI), ClientWidth,
      ifthen(Up, 0.5 + LHeight * (LI + 1), ComputeInterpolation(LHeight * LI,
      LHeight * (LI + 1))), BGRAWhite);
  end;
end;

procedure TGVTransition.DoStrips(ToRight: boolean);
// *** StripsRight et StripsLeft ***
var
 LI: Integer;
 LWidth: Single;
begin
  LWidth := ClientWidth / fVerticalStrips;
  for LI := 0 to fVerticalStrips do
  begin
    fLBGRAMask.FillRectAntialias(
      ifthen(ToRight, LWidth * LI, -0.5 + ComputeInterpolation(LWidth * (LI + 1),
      LWidth * LI - 1)), 0,
      ifthen(ToRight, 0.5 + ComputeInterpolation(LWidth * LI, LWidth * (1 + LI)),
        LWidth * (LI + 1)), ClientHeight, BGRAWhite);
  end;
end;

procedure TGVTransition.DoStripsHorizontalInterlaced(LeftFirst: boolean);
// *** StripsInterlacedLeftRight et StripsInterlacedRightLeft ***
var
 LI: Integer;
 LHeight: Single;
begin
  LHeight := ClientHeight / fHorizontalStrips;
  for LI := 0 to fHorizontalStrips do
    if (Odd(LI) and LeftFirst) or not (Odd(LI) or LeftFirst) then
      fLBGRAMask.FillRectAntialias(0, -0.5 + LHeight * LI,
        ComputeInterpolation(0, ClientWidth), LHeight * (LI + 1),
        BGRAWhite)
    else
      fLBGRAMask.FillRectAntialias(ComputeInterpolation(ClientWidth, 0),
        -0.5 + LHeight * LI, ClientWidth, LHeight * (LI + 1), BGRAWhite);
end;

procedure TGVTransition.DoStripsInterlaced(UpFirst: boolean);
// *** StripsInterlacedUpDown et StripsInterlacedDownUp ***
var
 LI: Integer;
 LWidth: Single;
begin
  LWidth := ClientWidth / fVerticalStrips;
  for LI := 0 to fVerticalStrips do
    if (Odd(LI) and UpFirst) or not (Odd(LI) or UpFirst) then
      fLBGRAMask.FillRectAntialias(LWidth * LI, 0, 0.5 + LWidth * (LI + 1),
        ComputeInterpolation(0, ClientHeight), BGRAWhite)
    else
      fLBGRAMask.FillRectAntialias(LWidth * LI, ClientHeight, 0.5 + LWidth * (LI + 1),
        ComputeInterpolation(ClientHeight, 0), BGRAWhite);
end;

procedure TGVTransition.DoRectUpOrDown(Up: Boolean);
// *** RectUpDown et RectDownUp ***
var
  LI, LJ: Integer;
  LHeight, LWidth: Single;
begin
  LHeight := ClientHeight / fHorizontalStrips;
  LWidth := ClientWidth / fVerticalStrips;
  for LI := -1 to fVerticalStrips do
    if not (Up and Odd(LI)) and (Up or Odd(LI)) then
      for LJ := -1 to fHorizontalStrips do
        if Odd(LJ) then
          fLBGRAMask.FillRectAntialias(LWidth * LI,
            LHeight * LJ,
            0.5 + LWidth * (LI + 1),
            ComputeInterpolation(LHeight * LJ, LHeight * (LJ + 2)),
            BGRAWhite)
        else
          fLBGRAMask.FillRectAntialias(LWidth * (LI + 1),
            ComputeInterpolation(LHeight * (LJ + 1), LHeight * (LJ - 1)),
            0.5 + LWidth * (LI + 2),
            LHeight * (LJ +1),
            BGRAWhite);
end;

procedure TGVTransition.DoWipe(ToRight: boolean);
// *** WipeRight et WipeLeft ***
var
 LR: single;
begin
  SetLength(fPts, 4);
  LR := sqrt(ClientWidth * ClientWidth + ClientHeight * ClientHeight);
  if ToRight then
    fPts := fLBGRAMask.ComputePieRad(0, ClientHeight, LR, LR,
      ComputeInterpolation(100, 0) * pi /200, 0)
  else
    fPts := fLBGRAMask.ComputePieRad(0, ClientHeight, LR, LR,
      0, ComputeInterpolation(1, 100) * pi /200);
  fLBGRAMask.FillPolyAntialias(fpts, BGRAWhite);
end;

procedure TGVTransition.DoOverSin(ToRight: boolean);
// *** OverLeftSin et OverRightSin ***
var
  LStep: Single;
begin
  LStep := ComputeInterpolation(0, 100);
  fX := ComputeInterpolation(ClientWidth, 0) * sin(LStep * pi / 200);
  if ToRight then
    fX := -fX;
  fY := ComputeInterpolation(ClientHeight, 0) * cos(LStep * pi / 200);
  DoBlank;
end;

function TGVTransition.Parabola(AOffset, AMax, APerCent: Integer): Single;
// *** calcul d'une parabole ***
var
  LSX, LSY: Single;
begin
  LSX := (AMax - AOffset) * ClientWidth / 100;
  LSY :=  ClientHeight * APerCent / 100;
  Result := -LSY / power(LSX, 2) *
    power(ClientWidth * (fStep * 100 / fLastLoop - AOffset) / 100 - LSX, 2) + LSY;
end;

procedure TGVTransition.DoBouncing(ToRight: boolean);
// *** BouncingRight et BouncingLeft ***
var
  LStep: Integer;
begin
  LStep := fStep * 100 div fLastLoop;
  if ToRight then
    fX := ComputeInterpolation(-ClientWidth , 0)
  else
    fX := ComputeInterpolation(ClientWidth , 0);
  case LStep of
    0..30: fY := -Parabola(0, 15, 80);
    31..50: fY := -Parabola(30, 40, 60);
    51..70: fY := -Parabola(50, 60, 50);
    71..80: fY := -Parabola(70, 75, 35);
    81..90: fY := -Parabola(80, 85, 20);
    91..100: fY := -Parabola(90, 95, 5);
  end;
  DoBlank;
end;

procedure TGVTransition.DoJump(ToRight: boolean);
// *** JumpRight et JumpLeft ***
begin
  if ToRight then
    fX := ComputeInterpolation(-ClientWidth, 0)
  else
    fX := ComputeInterpolation(ClientWidth, 0);
  fY := -Parabola(0, 50, 80);
  DoBlank;
end;

procedure TGVTransition.DoBlank;
// *** Masque blanc ***
begin
  fLBGRAMask.FillRectAntialias(fX, fY, fX + ClientWidth, fY + ClientHeight,
    BGRAWhite);
end;

procedure TGVTransition.DoFadeIn;
// *** FadeIn ***
begin
  DoBlank;
end;

// *** affichage final ***

procedure TGVTransition.DoRotateRight(CCW: boolean);
// *** CCWRotateRight et CWRotateRight ***
var
  L2Pi: Integer;
begin
  if CCW then
    L2Pi := -360
  else
    L2Pi := 360;
  fLBGRAFrom.PutImageAngle(ComputeInterpolation(0, ClientWidth / 2),
    ComputeInterpolation(ClientHeight, ClientHeight / 2),
    fLBGRATo, ComputeInterpolation(0, L2Pi), ClientWidth / 2,
    ClientHeight / 2, DestinationOpacity);
end;

procedure TGVTransition.DoCenterRotate(CCW: boolean);
// *** CCWCenterRotate et CWCenterRotate ***
var
  L2Pi: Integer;
begin
  if CCW then
    L2Pi := -360
  else
    L2Pi := 360;
  fLBGRAFrom.PutImageAngle(ClientWidth / 2, ClientHeight / 2,
    fLBGRATo, ComputeInterpolation(0, L2Pi) , ClientWidth / 2,
    ClientHeight / 2, DestinationOpacity);
end;

procedure TGVTransition.DoRotateLeft(CCW: boolean);
// *** CCWRotateLeft et CWRotateLeft ***
var
  L2Pi: Integer;
begin
  if CCW then
    L2Pi := -360
  else
    L2Pi := 360;
  fLBGRAFrom.PutImageAngle(ComputeInterpolation(ClientWidth * 3 / 2, ClientWidth / 2),
    ComputeInterpolation(ClientHeight * 3 / 2, ClientHeight / 2),
    fLBGRATo,  ComputeInterpolation(0, L2Pi) , ClientWidth / 2,
    ClientHeight / 2, DestinationOpacity);
end;

procedure TGVTransition.DoSpiral(CCW: Boolean);
// *** CCWSpiral et CWSpiral ***
var
  L2Pi: Integer;
begin
  if CCW then
    L2Pi := -360
  else
    L2Pi := 360;
  fLBGRAFrom.PutImageAngle(ClientWidth / 2, ClientHeight / 2,
    fLBGRATo,  ComputeInterpolation(0, L2Pi) , ComputeInterpolation(0, ClientWidth / 2),
    ComputeInterpolation(0, ClientHeight / 2), DestinationOpacity);
end;

procedure TGVTransition.DoGrowCenter;
// *** GrowCenter ***
begin
  fLBGRAFrom.StretchPutImage(Rect(ComputeInterpolationInt(ClientWidth div 2, 0),
    ComputeInterpolationInt(ClientHeight div 2, 0),
    ComputeInterpolationInt(ClientWidth div 2, ClientWidth),
    ComputeInterpolationInt(ClientHeight div 2, ClientHeight)),
    fLBGRATo, dmDrawWithTransparency, DestinationOpacity);
end;

procedure TGVTransition.DoGrowBottom(ToRight: Boolean);
// *** GrowBottomRight et GrowBottomLeft ***
begin
  if ToRight then
    fLBGRAFrom.StretchPutImage(Rect(0, 0,
      ComputeInterpolationInt(0, ClientWidth),
      ComputeInterpolationInt(0, ClientHeight)),
      fLBGRATo, dmDrawWithTransparency, DestinationOpacity)
  else
     fLBGRAFrom.StretchPutImage(Rect(ComputeInterpolationInt(ClientWidth, 0),
       0, ClientWidth, ComputeInterpolationInt(0, ClientHeight)),
       fLBGRATo, dmDrawWithTransparency, DestinationOpacity);
end;

procedure TGVTransition.DoGrowTop(ToRight: Boolean);
// *** GrowTopRight et GrowTopLeft ***
begin
  if ToRight then
    fLBGRAFrom.StretchPutImage(Rect(0, ComputeInterpolationInt(ClientHeight, 0),
      ComputeInterpolationInt(0, ClientWidth), ClientHeight),
      fLBGRATo, dmDrawWithTransparency, DestinationOpacity)
  else
     fLBGRAFrom.StretchPutImage(Rect(ComputeInterpolationInt(ClientWidth, 0),
       ComputeInterpolationInt(ClientHeight, 0), ClientWidth, ClientHeight),
       fLBGRATo, dmDrawWithTransparency, DestinationOpacity);
end;

procedure TGVTransition.DoGrowRotate(CCW: Boolean);
// *** GrowCWRotate et GrowCCWRotate ***
var
  LBGRATemp: TBGRABitmap;
begin
  LBGRATemp := fLBGRATo.Resample(
    ComputeInterpolationInt(C_MinResample, ClientWidth),
    ComputeInterpolationINt(C_MinResample, ClientHeight)) as TBGRABitmap;
  try
    fLBGRAFrom.PutImageAngle(ComputeInterpolation(ClientWidth / 2, 0),
      ComputeInterpolation(ClientHeight, 0), LBGRATemp,
      ifthen(CCW, ComputeInterpolation(360, 0), ComputeInterpolation(-360, 0)),
      0, 0, DestinationOpacity);
  finally
    LBGRATemp.Free;
  end;
end;

procedure TGVTransition.DoGrowCenterRotate(CCW: Boolean);
// *** GrowCenterCCWRotate et GrowCenterCWRotate ***
var
  LBGRATemp: TBGRABitmap;
begin
  LBGRATemp := fLBGRATo.Resample(
    ComputeInterpolationInt(C_MinResample, ClientWidth),
    ComputeInterpolationInt(C_MinResample, ClientHeight)) as TBGRABitmap;
  try
    fLBGRAFrom.PutImageAngle(ClientWidth / 2, ClientHeight / 2, LBGRATemp,
      ifthen(CCW, ComputeInterpolation(360, 0), ComputeInterpolation(-360, 0)),
      LBGRATemp.Width / 2, LBGRATemp.Height / 2,DestinationOpacity);
  finally
    LBGRATemp.Free;
  end;
end;

procedure TGVTransition.DoGrowOver(ToRight: Boolean);
// *** GrowOverRight et GrowOverLeft ***
begin
  if ToRight then
    fLBGRAFrom.StretchPutImage(Rect(0, 0,
      ComputeInterpolationInt(0, ClientWidth), ClientHeight),
      fLBGRATo, dmDrawWithTransparency, DestinationOpacity)
  else
    fLBGRAFrom.StretchPutImage(Rect(ComputeInterpolationInt(ClientWidth, 0),
      0, ClientWidth, ClientHeight),
      fLBGRATo, dmDrawWithTransparency, DestinationOpacity);
end;

procedure TGVTransition.DoGrowOverUpOrDown(Up: Boolean);
// *** GrowOverUp et GrowOverDown ***
begin
  if Up then
    fLBGRAFrom.StretchPutImage(Rect(0, ComputeInterpolationInt(ClientHeight, 0),
      ClientWidth, ClientHeight),
      fLBGRATo, dmDrawWithTransparency, DestinationOpacity)
  else
    fLBGRAFrom.StretchPutImage(Rect(0, 0,
      ClientWidth, ComputeInterpolationInt(0, ClientHeight)),
      fLBGRATo, dmDrawWithTransparency, DestinationOpacity);
end;

procedure TGVTransition.DoRotateGrowLeft(CCW: Boolean);
// *** RotateGrowCCWLeft et RotateGrowCWLeft ***
var
  LBGRATemp: TBGRAAffineBitmapTransform;
begin
  LBGRATemp := TBGRAAffineBitmapTransform.Create(fLBGRATo);
  try
    LBGRATemp.RotateDeg(ifthen(CCW, ComputeInterpolation(0, -360),
      ComputeInterpolation(0, 360)));
    LBGRATemp.Scale(fStep / fLastLoop);
    LBGRATemp.Translate(ComputeInterpolation(ClientWidth, 0),
      0);
    fLBGRAFrom.Fill(LBGRATemp, dmDrawWithTransparency);
  finally
    LBGRATemp.Free;
  end;
end;

procedure TGVTransition.DoRotateGrowTopLeft(CCW: Boolean);
// *** RotateGrowCCWTopLeft et RotateGrowCWTopLeft ***
var
  LBGRATemp: TBGRAAffineBitmapTransform;
begin
  LBGRATemp := TBGRAAffineBitmapTransform.Create(fLBGRATo);
  try
    LBGRATemp.RotateDeg(ifthen(CCW, ComputeInterpolation(0, -360),
      ComputeInterpolation(0, 360)));
    LBGRATemp.Scale(fStep / fLastLoop);
    LBGRATemp.Translate(ComputeInterpolation(ClientWidth, 0),
      ComputeInterpolation(ClientHeight, 0));
    fLBGRAFrom.Fill(LBGRATemp, dmDrawWithTransparency);
  finally
    LBGRATemp.Free;
  end;
end;

procedure TGVTransition.DoRotateTopLeft(CCW: Boolean);
// *** RotateCCWTopLeft et RotateCWTopLeft ***
var
  LBGRATemp: TBGRAAffineBitmapTransform;
begin
  LBGRATemp := TBGRAAffineBitmapTransform.Create(fLBGRATo);
  try
    LBGRATemp.RotateDeg(ifthen(CCW, ComputeInterpolation(0, -360),
      ComputeInterpolation(0, 360)));
    LBGRATemp.Translate(ComputeInterpolation(ClientWidth, 0),
    ComputeInterpolation(ClientHeight, 0));
    fLBGRAFrom.Fill(LBGRATemp, dmDrawWithTransparency);
  finally
    LBGRATemp.Free;
  end;
end;

procedure TGVTransition.DoRotateBottomRight(CCW: Boolean);
// *** RotateCWBottomright et RotateCCWBottomright ***
var
  LBGRATemp: TBGRAAffineBitmapTransform;
begin
  LBGRATemp := TBGRAAffineBitmapTransform.Create(fLBGRATo);
  try
    LBGRATemp.RotateDeg(ifthen(CCW, ComputeInterpolation(0, -360),
      ComputeInterpolation(0, 360)));
    LBGRATemp.Translate(ComputeInterpolation(0, ClientWidth),
    ComputeInterpolation(0, ClientHeight));
    fLBGRAFrom.Fill(LBGRATemp, dmDrawWithTransparency);
  finally
    LBGRATemp.Free;
  end;
end;

procedure TGVTransition.DoMappingDown;
// *** MappingDown ***
begin
  fLBGRAFrom.FillPolyLinearMapping(
    [PointF(ComputeInterpolation(ClientWidth / 2, 0), 0),
     PointF(ComputeInterpolation(ClientWidth / 2, ClientWidth), 0),
     PointF(ClientWidth, ComputeInterpolation(ClientHeight / 4, ClientHeight)),
     PointF(0, ComputeInterpolation(ClientHeight / 4, ClientHeight))],
     fLBGRATo,
     [PointF(0,0), PointF(ClientWidth,0), PointF(ClientWidth, ClientHeight),
      PointF(0, ClientHeight)], true);
end;

procedure TGVTransition.DoMappingUp;
// *** MappingUp ***
begin
  fLBGRAFrom.FillPolyLinearMapping(
    [PointF(ComputeInterpolation(ClientWidth / 2, 0),
      ComputeInterpolation(ClientHeight / 4 * 3, 0)),
     PointF(ComputeInterpolation(ClientWidth / 2, ClientWidth),
       ComputeInterpolation(ClientHeight / 4 * 3, 0)),
     PointF(ClientWidth, ClientHeight), PointF(0, ClientHeight)],
     fLBGRATo,
     [PointF(0,0), PointF(ClientWidth, 0), PointF(ClientWidth, ClientHeight),
      PointF(0,ClientHeight)], true);
end;

procedure TGVTransition.DoMultiTwirl;
// *** MultiTwirl ***
var
  LBGRATemp: TBGRAAffineScannerTransform;
  LTwirl: TBGRATwirlScanner;
begin
  LBGRATemp := TBGRAAffineScannerTransform.Create(fLBGRATo);
  try
    LBGRATemp.Scale(fStep / fLastLoop);
    LTwirl := TBGRATwirlScanner.Create(LBGRATemp,
      Point(ClientWidth div 2, ClientHeight div 2), (fLastLoop - fStep) *
	  ifthen(ClientWidth > ClientHeight, ClientWidth, ClientHeight));
    try
      fLBGRAFrom.Fill(LTwirl, dmDrawWithTransparency);
    finally
      LTwirl.Free;
    end;
  finally
    LBGRATemp.Free;
  end;
end;

procedure TGVTransition.DoTwirl;
// *** Twirl ***
var
  LBGRATemp: TBGRAAffineScannerTransform;
  LTwirl: TBGRATwirlScanner;
begin
  LBGRATemp := TBGRAAffineScannerTransform.Create(fLBGRATo);
  try
    LBGRATemp.Scale(fStep / fLastLoop);
    LTwirl := TBGRATwirlScanner.Create(LBGRATemp,
      Point(ClientWidth div 2, ClientHeight div 2),
        ifthen(ClientWidth > ClientHeight,
        ComputeInterpolation(ClientWidth, 0),
        ComputeInterpolation(ClientHeight, 0)), 2);
    try
      fLBGRAFrom.Fill(LTwirl, dmDrawWithTransparency);
    finally
      LTwirl.Free;
    end;
  finally
    LBGRATemp.Free;
  end;
end;

procedure TGVTransition.DoSphere;
// *** Sphere ***
var
  LBGRATemp: TBGRAAffineScannerTransform;
  LSphere: TBGRASphereDeformationScanner;
begin
  LBGRATemp := TBGRAAffineScannerTransform.Create(fLBGRATo);
  try
    LBGRATemp.Scale(fStep / fLastLoop);
    LSphere := TBGRASphereDeformationScanner.Create(LBGRATemp,
      PointF(ClientWidth / 2, ClientHeight / 2),
      ComputeInterpolation(ClientWidth, ClientWidth / 2),
      ComputeInterpolation(ClientHeight, ClientHeight / 2));
    try
      fLBGRAFrom.Fill(LSphere, dmDrawWithTransparency);
    finally
      LSphere.Free;
    end;
  finally
    LBGRATemp.Free;
  end;
end;

procedure TGVTransition.DoCylinderRight;
// *** CylinderRight ***
var
  LCylinder: TBGRAVerticalCylinderDeformationScanner;
begin
  LCylinder := TBGRAVerticalCylinderDeformationScanner.Create(fLBGRAFrom,
    ComputeInterpolation(0, ClientWidth),
    ClientWidth / fVerticalStrips);
  try
    fLBGRAFrom.Fill(LCylinder, dmDrawWithTransparency);
    fLBGRAFrom.PutImage(
      ComputeInterpolationInt(-ClientWidth, 0), 0, fLBGRATo, dmDrawWithTransparency,
      DestinationOpacity);
  finally
    LCylinder.Free;
  end;
end;

procedure TGVTransition.DoCylinderLeft;
// *** CylinderLeft ***
var
  LCylinder: TBGRAVerticalCylinderDeformationScanner;
begin
  LCylinder := TBGRAVerticalCylinderDeformationScanner.Create(fLBGRAFrom,
    ComputeInterpolation(ClientWidth, -ClientWidth / fVerticalStrips),
    ClientWidth / fVerticalStrips);
  try
    fLBGRAFrom.Fill(LCylinder, dmDrawWithTransparency);
    fLBGRAFrom.PutImage(
      ComputeInterpolationInt(ClientWidth, 0), 0, fLBGRATo, dmDrawWithTransparency,
      DestinationOpacity);
  finally
    LCylinder.Free;
  end;
end;

procedure TGVTransition.DoMultiExpand;
// *** MultiExpand ***
var
  LBGRATemp: TBGRAAffineScannerTransform;
begin
  LBGRATemp := TBGRAAffineScannerTransform.Create(fLBGRATo);
  try
    LBGRATemp.Scale(fStep / fLastLoop);
    LBGRATemp.Translate(ComputeInterpolation(ClientWidth / 2, 0),
      ComputeInterpolation(ClientHeight / 2, 0));
    fLBGRAFrom.Fill(LBGRATemp, dmDrawWithTransparency);
  finally
    LBGRATemp.Free;
  end;
end;

procedure TGVTransition.DoMultiExpandTwirl;
// *** MultiExpandTwirl ***
var
  LBGRATemp: TBGRAAffineScannerTransform;
  LTwirl: TBGRATwirlScanner;
begin
  Inc(fStep, fInc);
  LBGRATemp := TBGRAAffineScannerTransform.Create(fLBGRATo);
  try
    LBGRATemp.Scale(fStep / fLastLoop);
    LBGRATemp.Translate(ComputeInterpolation(ClientWidth / 2, 0),
        ComputeInterpolation(ClientHeight / 2, 0));
    LTwirl := TBGRATwirlScanner.Create(LBGRATemp,
      Point(ClientWidth div 2, ClientHeight div 2),
        ComputeInterpolation(ClientWidth / 2, 0));
    try
      fLBGRAFrom.Fill(LTwirl, dmDrawWithTransparency);
    finally
      LTwirl.Free;
    end;
  finally
    LBGRATemp.Free;
  end;
end;

procedure TGVTransition.DoDrawFromBounds;
// *** DrawFromBounds ***
var
  LBorder: TBGRAExtendedBorderScanner;
  LRect: TRect;
begin
    LRect := TRect.Create(ClientWidth div 2, ClientHeight div 2,
      ClientWidth div 2, ClientHeight div 2);
    LRect.Inflate(
      ComputeInterpolationInt(0, ClientWidth / 2),
      ComputeInterpolationInt(0, ClientHeight / 2));
    LBorder := TBGRAExtendedBorderScanner.Create(fLBGRATo, LRect);
    try
      fLBGRAFrom.Fill(LBorder, dmDrawWithTransparency);
    finally
      LBorder.Free;
    end;
end;

procedure TGVTransition.DoOffset(ToRight: Boolean);
// *** OffsetTopLeft et OffsetBottomRight ***
var
  LOffset: TBGRAScannerOffset;
begin
    LOffset := TBGRAScannerOffset.Create(fLBGRATo,
      Point(
      ifthen(ToRight, ComputeInterpolationInt(0, ClientWidth),
        ComputeInterpolationInt(ClientWidth, 0)),
      ifthen(ToRight, ComputeInterpolationInt(0, ClientHeight),
        ComputeInterpolationInt(ClientHeight, 0))));
    try
      fLBGRAFrom.Fill(LOffset, dmDrawWithTransparency);
    finally
      LOffset.Free;
    end;
end;

procedure TGVTransition.DoPixelate;
// *** Pixelate ***
var
  LBGRATemp: TBGRABitmap;
begin
  LBGRATemp := fLBGRATo.Duplicate as TBGRABitmap;
  try
    BGRAReplace(LBGRATemp, LBGRATemp.FilterPixelate(
      ComputeInterpolationInt(fLastLoop, 0), True));
    fLBGRAFrom.PutImage(0, 0, LBGRATemp, dmDrawWithTransparency, DestinationOpacity);
  finally
    LBGRATemp.Free;
  end;
end;

procedure TGVTransition.DoBlurMotion;
// *** BlurMotion ***
var
  LBGRATemp: TBGRABitmap;
begin
  LBGRATemp := fLBGRATo.Duplicate as TBGRABitmap;
  try
    BGRAReplace(LBGRATemp, LBGRATemp.FilterBlurMotion(
      ComputeInterpolation(fLastLoop / 2, 0),
      ComputeInterpolation(fLastLoop, 0), True));
    fLBGRAFrom.PutImage(0, 0, LBGRATemp, dmDrawWithTransparency, DestinationOpacity);
  finally
    LBGRATemp.Free;
  end;
end;

{$IFDEF Debug_Transitions}

procedure TGVTransition.DoInitDummy;
begin

end;

function TGVTRansition.DoSourceDummy: TBGRABitmap;
begin
  Result := fBGRAFrom.Duplicate as TBGRABitmap;
  
end;

procedure TGVTransition.DoDestinationDummy;
begin
  
end;

procedure TGVTransition.DoFinalDummy;
begin
 
end;
{$ENDIF}
